Index: boot/arch/arm64/include/arch/arch.h
===================================================================
--- boot/arch/arm64/include/arch/arch.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/include/arch/arch.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -41,7 +41,6 @@
 
 #define BOOT_OFFSET  0x80000
-
 #ifndef __ASSEMBLER__
-#define KA2PA(x)  (((uintptr_t) (x)) - UINT64_C(0xffffffff00000000))
+#define KA2PA(x)  (((uintptr_t) (x)) - UINT64_C(0xffffffff80000000))
 #endif
 
Index: boot/arch/arm64/include/arch/barrier.h
===================================================================
--- boot/arch/arm64/include/arch/barrier.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/include/arch/barrier.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,47 +1,1 @@
-/*
- * Copyright (c) 2015 Petr Pavlu
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup boot_arm64
- * @{
- */
-/** @file
- * @brief Memory barriers.
- */
-
-#ifndef BOOT_arm64_BARRIER_H_
-#define BOOT_arm64_BARRIER_H_
-
-#include <stddef.h>
-
-extern void smc_coherence(void *, size_t);
-extern void dcache_flush(void *, size_t);
-
-#endif
-
-/** @}
- */
+../../../../../kernel/arch/arm64/include/arch/barrier.h
Index: boot/arch/arm64/meson.build
===================================================================
--- boot/arch/arm64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -29,14 +29,7 @@
 BUILD = true
 
-if MACHINE == 'virt'
-	POST_OUTPUT = 'image.iso'
-	POSTBUILD = 'grub'
-	GRUB_LOADER = 'chainloader'
-endif
-
-if MACHINE == 'hikey960'
-	POSTBUILD = 'raw'
-	POST_OUTPUT = 'image.boot'
-endif
+POST_OUTPUT = 'image.iso'
+POSTBUILD = 'grub'
+GRUB_LOADER = 'chainloader'
 
 # Request binary output. The ARM64 port manually prepares the .text
Index: boot/arch/arm64/src/asm.S
===================================================================
--- boot/arch/arm64/src/asm.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/src/asm.S	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -33,6 +33,4 @@
 .section BOOTSTRAP
 
-#define DIRECTORY_ENTRIES 16
-
 /* MS-DOS stub */
 msdos_stub:
@@ -53,8 +51,6 @@
 	.long 0                         /* Number of symbols */
 	.short sec_table - opt_header   /* Size of optional header */
-	/*
-	 * Characteristics = IMAGE_FILE_EXECUTABLE_IMAGE |
-	 *   IMAGE_FILE_LARGE_ADDRESS_AWARE
-	 */
+	/* Characteristics = IMAGE_FILE_EXECUTABLE_IMAGE |
+	 *   IMAGE_FILE_LARGE_ADDRESS_AWARE */
 	.short 0x22
 
@@ -91,9 +87,8 @@
 	.quad 0                         /* Size of heap commit */
 	.long 0                         /* Loader flags */
-	.long DIRECTORY_ENTRIES         /* Number of RVA and sizes */
-	.space DIRECTORY_ENTRIES * 8    /* Directory entries */
+	.long 0                         /* Number of RVA and sizes */
 
 sec_table:
-	.ascii ".text\x0\x0\x0"         /* Name */
+        .ascii ".text\x0\x0\x0"         /* Name */
 	.long payload_end - start       /* Virtual size */
 	.long start - msdos_stub        /* Virtual address */
@@ -104,21 +99,19 @@
 	.short 0                        /* Number of relocations */
 	.short 0                        /* Number of line numbers */
-	/*
-	 * Characteristics = IMAGE_SCN_CNT_CODE | IMAGE_SCN_MEM_EXECUTE |
-	 *   IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE
-	 */
+	/* Characteristics = IMAGE_SCN_CNT_CODE | IMAGE_SCN_MEM_EXECUTE |
+	 *   IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE */
 	.long 0xe0000020
 
-/** Boot loader entry point
- *
- * @param x0 UEFI image handle.
- * @param x1 Pointer to the UEFI system table.
- *
- */
 SYMBOL(start)
 	.hidden start
 
 	/*
-	 * Stay on the UEFI stack. Its size is at least 128 KiB, plenty for this
+	 * Parameters:
+	 * x0 is the image handle.
+	 * x1 is a pointer to the UEFI system table.
+	 */
+
+	/*
+	 * Stay on the UEFI stack. Its size is at least 128 kB, plenty for this
 	 * boot loader.
 	 */
@@ -135,13 +128,5 @@
 	add x1, x1, #:lo12:_DYNAMIC
 	bl self_relocate
-	cbnz x0, __uefi_exit
-
-	/*
-	 * Flush the instruction cache of the relocated boot loader image.
-	 */
-	adr x0, msdos_stub
-	adrp x1, payload_end
-	sub x1, x1, x0
-	bl smc_coherence
+	cbnz x0, 0f
 
 	/*
@@ -153,7 +138,7 @@
 	bl bootstrap
 
-	__uefi_exit:
-		ldp x29, x30, [sp], #32
-		ret
+0:
+	ldp x29, x30, [sp], #32
+	ret
 
 FUNCTION_BEGIN(halt)
@@ -163,149 +148,19 @@
 FUNCTION_END(halt)
 
-/** Flush instruction caches
- *
- * @param x0 Starting address of the flushing.
- * @param x1 Number of bytes to flush.
- *
- */
-FUNCTION_BEGIN(smc_coherence)
-	.hidden smc_coherence
-
-	/* Initialize loop */
-	mov x9, x0
-	mov x10, xzr
-
-	__dc_loop:
-		/* Data or Unified Cache Line Clean */
-		dc cvau, x9
-		add x9, x9, #4
-		add x10, x10, #4
-		cmp x10, x1
-		blo __dc_loop
-
-	dsb ish
-
-	/* Initialize loop */
-	mov x9, x0
-	mov x10, xzr
-
-	__ic_loop:
-		/* Instruction Cache Line Invalidate */
-		ic ivau, x9
-		add x9, x9, #4
-		add x10, x10, #4
-		cmp x10, x1
-		blo __ic_loop
-
-	dsb ish
-	isb
-	ret
-FUNCTION_END(smc_coherence)
-
-/** Flush data caches
- *
- * @param x0 Starting address of the flushing.
- * @param x1 Number of bytes to flush.
- *
- */
-FUNCTION_BEGIN(dcache_flush)
-	.hidden dcache_flush
-
-	mov x9, x0
-	mov x10, xzr
-
-	__dc_flush_loop:
-		/* Data or Unified Cache Line Clean */
-		dc cvau, x9
-		add x9, x9, #4
-		add x10, x10, #4
-		cmp x10, x1
-		blo __dc_flush_loop
-
-	dsb ish
-	isb
-	ret
-FUNCTION_END(dcache_flush)
-
-/** Kernel entry
- *
- * @param x0 Kernel entry point.
- * @param x1 Pointer to the bootinfo structure.
- *
- */
 FUNCTION_BEGIN(jump_to_kernel)
 	.hidden jump_to_kernel
 
-	mrs x9, CurrentEL
-	lsr x9, x9, 2
+	/*
+	 * Parameters:
+	 * x0 is kernel entry point.
+	 * x1 is pointer to the bootinfo structure.
+	 */
 
-	cmp x9, #3
-	b.eq __el3
+	/* Disable MMU (removes the identity mapping provided by UEFI). */
+	mrs x2, sctlr_el1
+	bic x2, x2, #SCTLR_M_FLAG
+	msr sctlr_el1, x2
+	isb
 
-	cmp x9, #2
-	b.eq __el2
-
-	cmp x9, #1
-	b.eq __el1
-
-	b halt
-
-	__el3:
-		msr sctlr_el2, xzr
-		msr hcr_el2, xzr
-		isb
-
-		/* EL2 is AArch64, EL1 is Non-secure World */
-		mov x9, #(1 << 10)
-		orr x9, x9, #(1 << 0)
-		msr scr_el3, x9
-		isb
-
-		/* EL2h */
-		mov x9, #0x9
-		msr spsr_el3, x9
-		isb
-
-		adr x9, __el2
-		msr elr_el3, x9
-		isb
-
-		/* Switch to EL2 */
-		eret
-
-	__el2:
-		msr sctlr_el1, xzr
-		isb
-
-		/* EL1 is AArch64 */
-		mov x9, #(1 << 31)
-		msr hcr_el2, x9
-		isb
-
-		/* EL1h */
-		mov x9, #0x5
-		msr spsr_el2, x9
-		isb
-
-		adr x9, __el1
-		msr elr_el2, x9
-		isb
-
-		/* Switch to EL1 */
-		eret
-
-	__el1:
-		/* Do not trap on FPU instructions */
-		mrs x9, cpacr_el1
-		orr x9, x9, #(3 << 20)
-		msr cpacr_el1, x9
-		dmb ish
-
-		/* Disable MMU (removes the identity mapping provided by UEFI) */
-		mrs x9, sctlr_el1
-		bic x9, x9, #SCTLR_M_FLAG
-		msr sctlr_el1, x9
-		isb
-
-		br x0
+	br x0
 FUNCTION_END(jump_to_kernel)
Index: boot/arch/arm64/src/main.c
===================================================================
--- boot/arch/arm64/src/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ boot/arch/arm64/src/main.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -116,4 +116,5 @@
 {
 	efi_status_t status;
+	uint64_t current_el;
 	uint64_t memmap = 0;
 	sysarg_t memmap_size;
@@ -142,4 +143,13 @@
 	printf(" %p|%p: UEFI system table\n", efi_system_table_in,
 	    efi_system_table_in);
+
+	/* Validate the exception level. */
+	current_el = CurrentEL_read();
+	if (current_el != CURRENT_EL_EL1) {
+		printf("Error: Unexpected CurrentEL value %0#18" PRIx64 ".\n",
+		    current_el);
+		status = EFI_UNSUPPORTED;
+		goto fail;
+	}
 
 	/* Obtain memory map. */
@@ -177,5 +187,5 @@
 
 	/*
-	 * Check that everything is aligned on a 4 KiB boundary and the kernel can
+	 * Check that everything is aligned on a 4kB boundary and the kernel can
 	 * be placed by the decompression code at a correct address.
 	 */
@@ -189,9 +199,9 @@
 	 * Dynamically check the memory base. The condition should be always
 	 * true because UEFI guarantees each physical/virtual address in the
-	 * memory map is aligned on a 4 KiB boundary.
+	 * memory map is aligned on a 4kB boundary.
 	 */
 	if (!IS_ALIGNED(memory_base, PAGE_SIZE)) {
 		printf("Error: Start of usable RAM (%p) is not aligned on a "
-		    "4 KiB boundary.\n", (void *) memory_base);
+		    "4kB boundary.\n", (void *) memory_base);
 		status = EFI_UNSUPPORTED;
 		goto fail;
@@ -233,5 +243,5 @@
 
 	extract_payload(&bootinfo->taskmap, kernel_dest, ram_end,
-	    (uintptr_t) kernel_dest, smc_coherence);
+	    (uintptr_t) kernel_dest, ensure_visibility);
 
 	/* Get final memory map. */
@@ -291,7 +301,4 @@
 	bootinfo->memmap.cnt = cnt;
 
-	/* Flush the data cache containing bootinfo. */
-	dcache_flush(bootinfo, sizeof(*bootinfo));
-
 	uintptr_t entry = check_kernel_translated((void *) decompress_base,
 	    BOOT_OFFSET);
Index: defaults/arm64/output
===================================================================
--- defaults/arm64/output	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
+++ defaults/arm64/output	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -0,0 +1,1 @@
+image.iso
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/src/amd64.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -224,6 +224,4 @@
 	    ns16550_out_ptr);
 	if (ns16550_instance) {
-		ns16550_format_set(ns16550_instance, 38400,
-		    LCR_PARITY_NONE | LCR_STOP_BIT_TWO | LCR_WORD_LEN_8);
 #ifdef CONFIG_NS16550
 		srln_instance_t *srln_instance = srln_init();
Index: kernel/arch/amd64/src/asm.S
===================================================================
--- kernel/arch/amd64/src/asm.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/src/asm.S	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -411,6 +411,4 @@
 FUNCTION_BEGIN(early_putuchar)
 
-#if (defined(CONFIG_DEBUG_EARLY_PRINT))
-
 #if (defined(CONFIG_L4RE_UVMM_EARLY_PRINT))
 	xorl %eax, %eax  /* RAX==0: uvmm's print hypercall */
@@ -545,6 +543,4 @@
 #endif
 
-#endif
-
 	ret
 FUNCTION_END(early_putuchar)
Index: kernel/arch/arm32/include/arch/mm/page.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/include/arch/mm/page.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -159,7 +159,4 @@
 #endif
 	TTBR0_write(val);
-#if defined(PROCESSOR_ARCH_armv6) || defined(PROCESSOR_ARCH_armv7_a)
-	BPIALL_write(0);
-#endif
 }
 
Index: kernel/arch/arm32/src/cpu/cpu.c
===================================================================
--- kernel/arch/arm32/src/cpu/cpu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/cpu/cpu.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -170,4 +170,6 @@
 	 */
 	control_reg |= SCTLR_CACHE_EN_FLAG;
+#endif
+#ifdef PROCESSOR_ARCH_armv7_a
 	/*
 	 * ICache coherency is elaborated on in barrier.h.
Index: kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c
===================================================================
--- kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -174,13 +174,6 @@
 {
 #ifdef CONFIG_FB
-	uint32_t width, height;
 	fb_properties_t prop;
-
-	if (!bcm2835_mbox_get_fb_size(&width, &height)) {
-		printf("mbox: could not get the framebuffer size\n");
-		width = 640;
-		height = 480;
-	}
-	if (bcm2835_fb_init(&prop, width, height)) {
+	if (bcm2835_fb_init(&prop)) {
 		outdev_t *fb_dev = fb_init(&prop);
 		if (fb_dev)
Index: kernel/arch/arm64/include/arch/barrier.h
===================================================================
--- kernel/arch/arm64/include/arch/barrier.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/barrier.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -37,4 +37,44 @@
 #define KERN_arm64_BARRIER_H_
 
+#include <stddef.h>
+
+#define COHERENCE_INVAL_MIN  4
+
+/** Ensure visibility of instruction updates for a multiprocessor.
+ *
+ * @param addr Address of the first instruction.
+ * @param size Size of the instruction block (in bytes).
+ */
+static inline void ensure_visibility(void *addr, size_t len)
+{
+	size_t i;
+
+	/*
+	 * Clean to Point of Unification to make the new instructions visible to
+	 * the instruction cache.
+	 */
+	for (i = 0; i < len; i += COHERENCE_INVAL_MIN)
+		asm volatile (
+		    "dc cvau, %[addr]\n"
+		    : : [addr] "r" ((char *) addr + i)
+		);
+
+	/* Ensure completion on all PEs. */
+	asm volatile ("dsb ish" ::: "memory");
+
+	/* Ensure instruction cache/branch predictor discards stale data. */
+	for (i = 0; i < len; i += COHERENCE_INVAL_MIN)
+		asm volatile (
+		    "ic ivau, %[addr]\n"
+		    : : [addr] "r" ((char *) addr + i)
+		);
+
+	/* Ensure completion on all PEs. */
+	asm volatile ("dsb ish" ::: "memory");
+
+	/* Synchronize context on this PE. */
+	asm volatile ("isb");
+}
+
 #endif
 
Index: kernel/arch/arm64/include/arch/istate_struct.h
===================================================================
--- kernel/arch/arm64/include/arch/istate_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/istate_struct.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -65,6 +65,5 @@
 #define ISTATE_OFFSET_X29    0x108
 #define ISTATE_OFFSET_X30    0x110
-#define ISTATE_OFFSET_PAD0   0x118
-#define ISTATE_SIZE          0x120
+#define ISTATE_SIZE          0x118
 
 #ifndef __ASSEMBLER__
@@ -110,15 +109,6 @@
 	/* Link Register. */
 	uint64_t x30;
-
-	/*
-	 * ARM64 mandates that the stack pointer is always aligned to
-	 * a 16-byte boundary. To satisfy this condition, the size of
-	 * this data structure needs to be also a multiple of 16 bytes.
-	 * This is the reason for this padding.
-	 */
-	uint64_t pad0;
 } istate_t;
 
 #endif
-
 #endif
Index: kernel/arch/arm64/include/arch/mach/virt/virt.h
===================================================================
--- kernel/arch/arm64/include/arch/mach/virt/virt.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/mach/virt/virt.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -36,6 +36,6 @@
  */
 
-#ifndef KERN_arm64_mach_virt_H_
-#define KERN_arm64_mach_virt_H_
+#ifndef KERN_arm64_virt_H_
+#define KERN_arm64_virt_H_
 
 #include <arch/machine_func.h>
Index: kernel/arch/arm64/include/arch/machine_func.h
===================================================================
--- kernel/arch/arm64/include/arch/machine_func.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/machine_func.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -50,5 +50,4 @@
 	size_t (*machine_get_irq_count)(void);
 	const char *(*machine_get_platform_name)(void);
-	void (*machine_early_uart_output)(char32_t);
 };
 
@@ -61,5 +60,4 @@
 extern size_t machine_get_irq_count(void);
 extern const char *machine_get_platform_name(void);
-extern void machine_early_uart_output(char32_t);
 
 #endif
Index: kernel/arch/arm64/include/arch/mm/km.h
===================================================================
--- kernel/arch/arm64/include/arch/mm/km.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/mm/km.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -41,9 +41,9 @@
 #include <typedefs.h>
 
-#define KM_ARM64_IDENTITY_START  UINT64_C(0xffffffff00000000)
-#define KM_ARM64_IDENTITY_SIZE   UINT64_C(0x0000000100000000)
+#define KM_ARM64_IDENTITY_START  UINT64_C(0xffffffff80000000)
+#define KM_ARM64_IDENTITY_SIZE   UINT64_C(0x0000000080000000)
 
 #define KM_ARM64_NON_IDENTITY_START  UINT64_C(0xffff000000000000)
-#define KM_ARM64_NON_IDENTITY_SIZE   UINT64_C(0x0000ffff00000000)
+#define KM_ARM64_NON_IDENTITY_SIZE   UINT64_C(0x0000ffff80000000)
 
 extern void km_identity_arch_init(void);
@@ -53,9 +53,9 @@
 #else /* __ASSEMBLER__ */
 
-#define KM_ARM64_IDENTITY_START  0xffffffff00000000
-#define KM_ARM64_IDENTITY_SIZE   0x0000000100000000
+#define KM_ARM64_IDENTITY_START  0xffffffff80000000
+#define KM_ARM64_IDENTITY_SIZE   0x0000000080000000
 
 #define KM_ARM64_NON_IDENTITY_START  0xffff000000000000
-#define KM_ARM64_NON_IDENTITY_SIZE   0x0000ffff00000000
+#define KM_ARM64_NON_IDENTITY_SIZE   0x0000ffff80000000
 
 #endif /* __ASSEMBLER__ */
Index: kernel/arch/arm64/include/arch/mm/page.h
===================================================================
--- kernel/arch/arm64/include/arch/mm/page.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/include/arch/mm/page.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -53,7 +53,7 @@
 
 #define KA2PA(x) \
-	(((uintptr_t) (x)) - UINT64_C(0xffffffff00000000) + physmem_base)
+	(((uintptr_t) (x)) - UINT64_C(0xffffffff80000000) + physmem_base)
 #define PA2KA(x) \
-	(((uintptr_t) (x)) + UINT64_C(0xffffffff00000000) - physmem_base)
+	(((uintptr_t) (x)) + UINT64_C(0xffffffff80000000) - physmem_base)
 
 #endif /* __ASSEMBLER__ */
Index: kernel/arch/arm64/meson.build
===================================================================
--- kernel/arch/arm64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -44,4 +44,5 @@
 	'src/mm/page.c',
 	'src/mm/tlb.c',
+	'src/smc.c',
 	'src/smp/ipi.c',
 	'src/smp/smp.c',
@@ -51,8 +52,4 @@
 if MACHINE == 'virt'
 	arch_src += files('src/mach/virt/virt.c')
-endif
-
-if MACHINE == 'hikey960'
-	arch_src += files('src/mach/hikey960/hikey960.c')
 endif
 
Index: kernel/arch/arm64/src/arm64.c
===================================================================
--- kernel/arch/arm64/src/arm64.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/src/arm64.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -40,5 +40,4 @@
 #include <arch/exception.h>
 #include <arch/machine_func.h>
-#include <console/console.h>
 #include <interrupt.h>
 #include <proc/scheduler.h>
@@ -257,14 +256,4 @@
 }
 
-void early_putuchar(char32_t c)
-{
-#ifdef CONFIG_DEBUG_EARLY_PRINT
-	if (c == '\n')
-		machine_early_uart_output('\r');
-
-	machine_early_uart_output(c);
-#endif
-}
-
 /** @}
  */
Index: kernel/arch/arm64/src/asm.S
===================================================================
--- kernel/arch/arm64/src/asm.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/src/asm.S	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -56,41 +56,7 @@
 FUNCTION_END(memcpy_to_uspace_failover_address)
 
-/** Flush instruction caches
- *
- * @param x0 Starting address of the flushing.
- * @param x1 Number of bytes to flush.
- *
- */
-FUNCTION_BEGIN(smc_coherence)
-	/* Initialize loop */
-	mov x9, x0
-	mov x10, xzr
-
-	__dc_loop:
-		/* Data or Unified Cache Line Clean */
-		dc cvau, x9
-		add x9, x9, #4
-		add x10, x10, #4
-		cmp x10, x1
-		blo __dc_loop
-
-	dsb ish
-
-	/* Initialize loop */
-	mov x9, x0
-	mov x10, xzr
-
-	__ic_loop:
-		/* Instruction Cache Line Invalidate */
-		ic ivau, x9
-		add x9, x9, #4
-		add x10, x10, #4
-		cmp x10, x1
-		blo __ic_loop
-
-	dsb ish
-	isb
+FUNCTION_BEGIN(early_putuchar)
 	ret
-FUNCTION_END(smc_coherence)
+FUNCTION_END(early_putuchar)
 
 /* Static checks for the istate_t save/load. */
Index: kernel/arch/arm64/src/machine_func.c
===================================================================
--- kernel/arch/arm64/src/machine_func.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/src/machine_func.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -37,5 +37,4 @@
 
 #include <arch/machine_func.h>
-#include <arch/mach/hikey960/hikey960.h>
 #include <arch/mach/virt/virt.h>
 
@@ -48,6 +47,4 @@
 #if defined(MACHINE_virt)
 	machine_ops = &virt_machine_ops;
-#elif defined(MACHINE_hikey960)
-	machine_ops = &hikey960_machine_ops;
 #else
 #error Machine type not defined.
@@ -101,11 +98,4 @@
 }
 
-/** Early debugging output. */
-void machine_early_uart_output(char32_t c)
-{
-	if (machine_ops->machine_early_uart_output != NULL)
-		machine_ops->machine_early_uart_output(c);
-}
-
 /** @}
  */
Index: kernel/arch/arm64/src/smc.c
===================================================================
--- kernel/arch/arm64/src/smc.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
+++ kernel/arch/arm64/src/smc.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2019 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <arch/barrier.h>
+#include <barrier.h>
+
+void smc_coherence(void *a, size_t l)
+{
+	ensure_visibility(a, l);
+}
Index: kernel/arch/arm64/src/start.S
===================================================================
--- kernel/arch/arm64/src/start.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/arm64/src/start.S	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -35,40 +35,21 @@
 .section K_TEXT_START, "ax"
 
-.macro dcache_flush addr size temp0 temp1
-	mov \temp0, \addr
-	mov \temp1, xzr
-
-	0:
-		/* Data or Unified Cache Line Clean */
-		dc cvau, \temp0
-		add \temp0, \temp0, #4
-		add \temp1, \temp1, #4
-		cmp \temp1, \size
-		blo 0b
-
-	dsb ish
-	isb
-.endm
-
-/** Kernel entry
- *
- * MMU must be disabled at this point.
- *
- * @param x0 Kernel entry point (kernel_image_start).
- * @param x1 Pointer to the bootinfo structure.
- *
- */
 SYMBOL(kernel_image_start)
+	/*
+	 * Parameters:
+	 * x0 is kernel entry point (kernel_image_start).
+	 * x1 is pointer to the bootinfo structure.
+	 *
+	 * MMU must be disabled at this point.
+	 */
+
 	/* Get address of the main memory and remember it. */
 	adrp x20, kernel_image_start - BOOT_OFFSET
 	adrp x2, physmem_base
+	/* add x2, x2, #:lo12:physmem_base */
 	str x20, [x2]
 
-	/* Flush the data cache of physmem_base. */
-	mov x28, #8
-	dcache_flush x2 x28 x29 x30
-
-	/*
-	 * Set up address translation that identity maps the 1 GiB area that
+	/*
+	 * Set up address translation that identity maps the gigabyte area that
 	 * is holding the current execution page.
 	 */
@@ -95,5 +76,5 @@
 	mov x3, #( \
 	    1 << PTE_ACCESS_SHIFT | \
-	    MAIR_EL1_NORMAL_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
+	    MAIR_EL1_DEVICE_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
 	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
 	    1 << PTE_PRESENT_SHIFT)
@@ -103,11 +84,10 @@
 
 	/*
-	 * Set up address translation that maps the first 4 GiB of the kernel
-	 * identity virtual address space to the first 4 GiB of the physical
+	 * Set up address translation that maps the first gigabyte of the kernel
+	 * identity virtual address space to the first gigabyte of the physical
 	 * memory.
 	 */
 
 	mov x21, #KM_ARM64_IDENTITY_START
-	ldr x22, =(1024 * 1024 * 1024)
 
 	/* Prepare the level 0 page table. */
@@ -132,5 +112,5 @@
 	mov x3, #( \
 	    1 << PTE_ACCESS_SHIFT | \
-	    MAIR_EL1_NORMAL_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
+	    MAIR_EL1_DEVICE_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
 	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
 	    1 << PTE_PRESENT_SHIFT)
@@ -138,72 +118,4 @@
 	orr x3, x3, x4, lsl #PTE_OUTPUT_ADDRESS_SHIFT
 	str x3, [x2]
-
-	/* 2nd GiB */
-	add x23, x20, x22
-	add x24, x21, x22
-
-	adrp x2, upper_page_table_level1
-	lsr x3, x24, #PTL1_VA_SHIFT
-	and x3, x3, #PTL1_VA_MASK
-	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
-	mov x3, #( \
-	    1 << PTE_ACCESS_SHIFT | \
-	    MAIR_EL1_NORMAL_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
-	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
-	    1 << PTE_PRESENT_SHIFT)
-	lsr x4, x23, #FRAME_WIDTH
-	orr x3, x3, x4, lsl #PTE_OUTPUT_ADDRESS_SHIFT
-	str x3, [x2]
-
-	/* 3rd GiB */
-	add x23, x23, x22
-	add x24, x24, x22
-
-	adrp x2, upper_page_table_level1
-	lsr x3, x24, #PTL1_VA_SHIFT
-	and x3, x3, #PTL1_VA_MASK
-	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
-	mov x3, #( \
-	    1 << PTE_ACCESS_SHIFT | \
-	    MAIR_EL1_NORMAL_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
-	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
-	    1 << PTE_PRESENT_SHIFT)
-	lsr x4, x23, #FRAME_WIDTH
-	orr x3, x3, x4, lsl #PTE_OUTPUT_ADDRESS_SHIFT
-	str x3, [x2]
-
-	/* 4th GiB */
-	add x23, x23, x22
-	add x24, x24, x22
-
-	adrp x2, upper_page_table_level1
-	lsr x3, x24, #PTL1_VA_SHIFT
-	and x3, x3, #PTL1_VA_MASK
-	add x2, x2, x3, lsl #PTL_ENTRY_SIZE_SHIFT
-	mov x3, #( \
-	    1 << PTE_ACCESS_SHIFT | \
-	    MAIR_EL1_DEVICE_MEMORY_INDEX << PTE_ATTR_INDEX_SHIFT | \
-	    PTE_L012_TYPE_BLOCK << PTE_TYPE_SHIFT | \
-	    1 << PTE_PRESENT_SHIFT)
-	lsr x4, x23, #FRAME_WIDTH
-	orr x3, x3, x4, lsl #PTE_OUTPUT_ADDRESS_SHIFT
-	str x3, [x2]
-
-	/* Flush the data cache of page tables. */
-	adrp x27, lower_page_table_level0
-	mov x28, #4096
-	dcache_flush x27 x28 x29 x30
-
-	adrp x27, lower_page_table_level1
-	mov x28, #4096
-	dcache_flush x27 x28 x29 x30
-
-	adrp x27, upper_page_table_level0
-	mov x28, #4096
-	dcache_flush x27 x28 x29 x30
-
-	adrp x27, upper_page_table_level1
-	mov x28, #4096
-	dcache_flush x27 x28 x29 x30
 
 	/* Make sure there are not any stale TLB entries. */
@@ -359,11 +271,8 @@
 lower_page_table_level0:
 	.space 4096
-
 lower_page_table_level1:
 	.space 4096
-
 upper_page_table_level0:
 	.space 4096
-
 upper_page_table_level1:
 	.space 4096
Index: kernel/arch/ia32/src/asm.S
===================================================================
--- kernel/arch/ia32/src/asm.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/asm.S	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -453,5 +453,5 @@
 FUNCTION_BEGIN(early_putuchar)
 
-#if ((defined(CONFIG_DEBUG_EARLY_PRINT)) && (defined(CONFIG_EGA)) && (!defined(CONFIG_FB)))
+#if ((defined(CONFIG_EGA)) && (!defined(CONFIG_FB)))
 
 	/* Prologue, save preserved registers */
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/ia32/src/ia32.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -209,6 +209,4 @@
 	    ns16550_out_ptr);
 	if (ns16550_instance) {
-		ns16550_format_set(ns16550_instance, 38400,
-		    LCR_PARITY_NONE | LCR_STOP_BIT_TWO | LCR_WORD_LEN_8);
 #ifdef CONFIG_NS16550
 		srln_instance_t *srln_instance = srln_init();
Index: kernel/arch/sparc64/include/arch/sun4v/cpu.h
===================================================================
--- kernel/arch/sparc64/include/arch/sun4v/cpu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/include/arch/sun4v/cpu.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -54,5 +54,5 @@
 	uint64_t cpuids[MAX_CORE_STRANDS];
 	struct cpu *cpus[MAX_CORE_STRANDS];
-	atomic_size_t nrdy;
+	atomic_t nrdy;
 	SPINLOCK_DECLARE(proposed_nrdy_lock);
 } exec_unit_t;
Index: kernel/genarch/include/genarch/drivers/bcm2835/mbox.h
===================================================================
--- kernel/genarch/include/genarch/drivers/bcm2835/mbox.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/include/genarch/drivers/bcm2835/mbox.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -68,11 +68,4 @@
 
 enum {
-	MBOX_TAG_GET_PHYS_W_H	= 0x00040003,
-	MBOX_TAG_SET_PHYS_W_H	= 0x00048003,
-	MBOX_TAG_GET_VIRT_W_H	= 0x00040004,
-	MBOX_TAG_SET_VIRT_W_G	= 0x00048004
-};
-
-enum {
 	MBOX_PROP_CODE_REQ	= 0x00000000,
 	MBOX_PROP_CODE_RESP_OK	= 0x80000000,
@@ -129,14 +122,4 @@
 
 typedef struct {
-	mbox_prop_buf_hdr_t	buf_hdr;
-	mbox_tag_hdr_t		tag_hdr;
-	struct {
-		uint32_t	width;
-		uint32_t	height;
-	} body;
-	uint32_t zero;
-} mbox_getfbsize_buf_t;
-
-typedef struct {
 	ioport32_t width;
 	ioport32_t height;
@@ -152,6 +135,5 @@
 
 extern bool bcm2835_prop_get_memory(uint32_t *base, uint32_t *size);
-extern bool bcm2835_fb_init(fb_properties_t *prop, uint32_t width, uint32_t heigth);
-extern bool bcm2835_mbox_get_fb_size(uint32_t *h, uint32_t *w);
+extern bool bcm2835_fb_init(fb_properties_t *prop);
 
 #endif
